Index: /BAORadio/libindi/libindi/examples/tutorial_two.c
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_two.c	(revision 503)
+++ /BAORadio/libindi/libindi/examples/tutorial_two.c	(revision 504)
@@ -102,5 +102,5 @@
 static INumber eqNR[] = {{"RA" ,"RA  H:M:S" , "%10.6m" ,0. , 24., 0., 0., 0, 0, 0},
 			 {"DEC", "Dec D:M:S", "%10.6m", -90., 90., 0., 0., 0, 0, 0}};
-static INumberVectorProperty eqNPR = {  mydev, "EQUATORIAL_EOD_COORD_REQUEST", "Equatorial Request",  MAIN_GROUP , IP_RW, 0, IPS_IDLE,  eqNR, NARRAY(eqNR), "", 0};
+static INumberVectorProperty eqNPR = {  mydev, "EQUATORIAL_EOD_COORD_REQUEST", "Equatorial Request",  MAIN_GROUP , IP_WO, 0, IPS_IDLE,  eqNR, NARRAY(eqNR), "", 0};
 
 /* Property naming convention. All property names are lower case with a postfix to indicate their type. connectS is a switch, 
@@ -122,4 +122,8 @@
 ISwitchVectorProperty MovementWESP      = { mydev, "TELESCOPE_MOTION_WE", "West/East", MAIN_GROUP, IP_RW, ISR_ATMOST1, 0, IPS_IDLE, MovementWES, NARRAY(MovementWES), "", 0};
 
+static ISwitch OnCoordSetS[] = {{"TRACK", "Track", ISS_ON, 0, 0}};
+static ISwitchVectorProperty OnCoordSetSP = {mydev, "ON_COORD_SET", "On Set", MAIN_GROUP, IP_RW, ISR_1OFMANY, 0, IPS_OK, OnCoordSetS, NARRAY(OnCoordSetS), "", 0};
+
+
 /* Initlization routine */
 static void mountInit()
@@ -149,4 +153,5 @@
 	IDDefSwitch (&MovementNSSP, NULL);
 	IDDefSwitch (&MovementWESP, NULL);
+        IDDefSwitch(&OnCoordSetSP, NULL);
 	
 }
@@ -276,4 +281,9 @@
 		}
 	}
+        else if (! strcmp(name, OnCoordSetSP.name))
+        {
+            OnCoordSetSP.s = IPS_OK;
+            IDSetSwitch(&OnCoordSetSP, NULL);
+        }
 	
 	
Index: /BAORadio/libindi/libindi/indiapi.h
===================================================================
--- /BAORadio/libindi/libindi/indiapi.h	(revision 503)
+++ /BAORadio/libindi/libindi/indiapi.h	(revision 504)
@@ -75,5 +75,5 @@
 
 /* INDI Library version */
-#define INDI_LIBV	0.7
+#define INDI_LIBV	0.8
 
 /*******************************************************************************
Index: /BAORadio/libindi/libindi/indidriver.c
===================================================================
--- /BAORadio/libindi/libindi/indidriver.c	(revision 503)
+++ /BAORadio/libindi/libindi/indidriver.c	(revision 504)
@@ -323,4 +323,5 @@
 void IUFillBLOB(IBLOB *bp, const char *name, const char * label, const char *format)
 {
+    memset(bp, 0, sizeof(IBLOB));
     strncpy(bp->name, name, MAXINDINAME);
     strncpy(bp->label, label, MAXINDILABEL);
@@ -341,5 +342,4 @@
   strncpy(svp->label, label, MAXINDILABEL);
   strncpy(svp->group, group, MAXINDIGROUP);
-  strcpy(svp->timestamp, "");
   
   svp->p	= p;
@@ -399,4 +399,5 @@
 void IUFillBLOBVector(IBLOBVectorProperty *bvp, IBLOB *bp, int nbp, const char * dev, const char *name, const char *label, const char* group, IPerm p, double timeout, IPState s)
 {
+    memset(bvp, 0, sizeof(IBLOBVectorProperty));
     strncpy(bvp->device, dev, MAXINDIDEVICE);
     strncpy(bvp->name, name, MAXINDINAME);
@@ -405,10 +406,9 @@
     strcpy(bvp->timestamp, "");
 
-  bvp->p	= p;
-  bvp->timeout	= timeout;
-  bvp->s	= s;
-  bvp->bp	= bp;
-  bvp->nbp	= nbp;
-
+    bvp->p	= p;
+    bvp->timeout	= timeout;
+    bvp->s	= s;
+    bvp->bp	= bp;
+    bvp->nbp	= nbp;
 }
 
Index: /BAORadio/libindi/libindi/indiserver.c
===================================================================
--- /BAORadio/libindi/libindi/indiserver.c	(revision 503)
+++ /BAORadio/libindi/libindi/indiserver.c	(revision 504)
@@ -84,11 +84,14 @@
     char dev[MAXINDIDEVICE];
     char name[MAXINDINAME];
+    BLOBHandling blob;			/* when to snoop BLOBs */
 } Property;
 
-/* record of each snooped property */
+
+/* record of each snooped property
 typedef struct {
     Property prop;
-    BLOBHandling blob;			/* when to snoop BLOBs */
-} Snoopee;
+    BLOBHandling blob;
+} Property;
+*/
 
 struct
@@ -119,5 +122,5 @@
     char dev[MAXINDIDEVICE];		/* device served by this driver */
     int active;				/* 1 when this record is in use */
-    Snoopee *sprops;			/* malloced array of props we snoop */
+    Property *sprops;			/* malloced array of props we snoop */
     int nsprops;			/* n entries in sprops[] */
     int pid;				/* process id or REMOTEDVR if remote */
@@ -163,6 +166,6 @@
     Msg *mp, XMLEle *root);
 static void addSDevice (DvrInfo *dp, const char *dev, const char *name);
-static Snoopee *findSDevice (DvrInfo *dp, const char *dev, const char *name);
-static void addClDevice (ClInfo *cp, const char *dev, const char *name);
+static Property *findSDevice (DvrInfo *dp, const char *dev, const char *name);
+static void addClDevice (ClInfo *cp, const char *dev, const char *name, int isblob);
 static int findClDevice (ClInfo *cp, const char *dev, const char *name);
 static int readFromDriver (DvrInfo *dp);
@@ -175,5 +178,6 @@
 static int sendClientMsg (ClInfo *cp);
 static int sendDriverMsg (DvrInfo *cp);
-static void crackBLOB (char *enableBLOB, BLOBHandling *bp);
+static void crackBLOB (const char *enableBLOB, BLOBHandling *bp);
+static void crackBLOBHandling(const char *dev, const char *name, const char *enableBLOB, ClInfo *cp);
 static void traceMsg (XMLEle *root);
 static char *indi_tstamp (char *s);
@@ -433,5 +437,5 @@
 	dp->lp = newLilXML();
         dp->msgq = newFQ(1);
-	dp->sprops = (Snoopee*) malloc (1);	/* seed for realloc */
+        dp->sprops = (Property*) malloc (1);	/* seed for realloc */
 	dp->nsprops = 0;
 	dp->nsent = 0;
@@ -484,5 +488,5 @@
 	dp->lp = newLilXML();
 	dp->msgq = newFQ(1);
-	dp->sprops = (Snoopee*) malloc (1);	/* seed for realloc */
+        dp->sprops = (Property*) malloc (1);	/* seed for realloc */
 	dp->nsprops = 0;
 	dp->nsent = 0;
@@ -737,5 +741,5 @@
     static char *envDev=NULL, *envConfig=NULL;
     const char *delm = " ";
-    char *token, *cp;
+    char *token, *cp, *tp;
     DvrInfo *dp = NULL;
     int startCmd=0;
@@ -748,5 +752,6 @@
     while ( fgets (line, MAXRBUF, fifo.fs) != NULL)
     {
-        //fprintf(stderr, "FIFO: %s\n", line);
+        fprintf(stderr, "FIFO: %s\n", line);
+
         tDev[0] = '\0', tDriver[0] = '\0', tConfig[0] = '\0', envDev[0] = '\0', envConfig[0] = '\0';
         cp = strdup(line);
@@ -756,4 +761,6 @@
         if (!strcmp(token, "start") || !strcmp(token, "stop"))
         {
+            //fprintf(stderr, "TOKEN: %s\n", token);
+
                 if (!strcmp(token, "start"))
                     startCmd = 1;
@@ -765,4 +772,6 @@
 
                strncpy(tDriver, token, MAXRBUF);
+               if (tp = strchr(tDriver, '\n'))
+                   *tp = '\0';
 
                if (verbose)
@@ -785,7 +794,8 @@
                      strcat(tDev, " ");
                      strncat(tDev, token, MAXRBUF);
-                     if (strstr(token, "\"") || strstr(token, "'"))
+                     if ( (tp=strchr(tDev, '\"')) || (tp=strchr(tDev, '\'')))
                      {
-                         tDev[strlen(tDev)-1] = '\0';
+                         //tDev[strlen(tDev)-1] = '\0';
+                         *tp='\0';
                          break;
                      }
@@ -793,5 +803,9 @@
                  }
                  else
+                {
                      strncpy(tDev, token, MAXRBUF);
+                     if (tp = strchr(tDev, '\n'))
+                         *tp = '\0';
+                 }
 
                   /* Find config, if there is any */
@@ -808,13 +822,18 @@
                           strncat(tConfig, token, MAXRBUF);
 
-                          if (strstr(token, "\"") || strstr(token, "'"))
+                          if ( (tp=strchr(tConfig, '\"')) || (tp=strchr(tConfig, '\'')))
                           {
-                                 tConfig[strlen(tConfig)-1] = '\0';
-                                 break;
+                                 //tConfig[strlen(tConfig)-1] = '\0';
+                              *tp = '\0';
+                              break;
                           }
                        }
                       }
                        else
+                      {
                            strncpy(tConfig, token, MAXRBUF);
+                           if (tp = strchr(tConfig, '\n'))
+                               *tp = '\0';
+                       }
                   }
               }
@@ -824,5 +843,8 @@
                {
                  snprintf(envDev, MAXRBUF, "INDIDEV=%s", tDev);
-                 //fprintf(stderr, "With name: %s\n", envDev);
+
+                 if (verbose)
+                    fprintf(stderr, "With name: %s\n", envDev);
+
                  putenv(envDev);
 
@@ -834,5 +856,8 @@
                {
                    snprintf(envConfig, MAXRBUF, "INDICONFIG=%s", tConfig);
-                   //fprintf(stderr, "With config: %s\n", envConfig);
+
+                   if (verbose)
+                    fprintf(stderr, "With config: %s\n", envConfig);
+
                    putenv(envConfig);
                }
@@ -978,5 +1003,5 @@
 		 */
 		if (dev[0])
-		    addClDevice (cp, dev, name);
+                    addClDevice (cp, dev, name, isblob);
 		else if (!strcmp (roottag, "getProperties") && !cp->nprops)
 		    cp->allprops = 1;
@@ -984,5 +1009,6 @@
 		/* snag enableBLOB -- send to remote drivers too */
 		if (!strcmp (roottag, "enableBLOB"))
-		    crackBLOB (pcdataXMLEle(root), &cp->blob);
+                   // crackBLOB (pcdataXMLEle(root), &cp->blob);
+                     crackBLOBHandling (dev, name, pcdataXMLEle(root), cp);
 
 		/* build a new message -- set content iff anyone cares */
@@ -1073,5 +1099,5 @@
 		/* that's all if driver is just registering a BLOB mode */
 		if (!strcmp (roottag, "enableBLOB")) {
-		    Snoopee *sp = findSDevice (dp, dev, name);
+                    Property *sp = findSDevice (dp, dev, name);
 		    if (sp)
 			crackBLOB (pcdataXMLEle (root), &sp->blob);
@@ -1094,5 +1120,5 @@
 
 		/* send to interested clients */
-		if (q2Clients (NULL, isblob, dev, name, mp, root) < 0)
+                if (q2Clients (NULL, isblob, dev, name, mp, root) < 0)
 		    shutany++;
 
@@ -1244,4 +1270,6 @@
 	for (dp = dvrinfo; dp < &dvrinfo[ndvrinfo]; dp++) {
 	    int isremote = (dp->pid == REMOTEDVR);
+            if (dp->active == 0)
+                continue;
 	    if (dev[0] && dp->dev[0] && strcmp (dev, dp->dev))
 		continue;	/* driver known to not support this dev */
@@ -1271,5 +1299,5 @@
 
 	for (dp = dvrinfo; dp < &dvrinfo[ndvrinfo]; dp++) {
-	    Snoopee *sp = findSDevice (dp, dev, name);
+            Property *sp = findSDevice (dp, dev, name);
 
 	    /* nothing for dp if not snooping for dev/name or wrong BLOB mode */
@@ -1297,5 +1325,5 @@
 addSDevice (DvrInfo *dp, const char *dev, const char *name)
 {
-	Snoopee *sp;
+        Property *sp;
 	char *ip;
 
@@ -1306,13 +1334,13 @@
 
 	/* add dev to sdevs list */
-	dp->sprops = (Snoopee*) realloc (dp->sprops,
-					    (dp->nsprops+1)*sizeof(Snoopee));
+        dp->sprops = (Property*) realloc (dp->sprops,
+                                            (dp->nsprops+1)*sizeof(Property));
 	sp = &dp->sprops[dp->nsprops++];
 
-	ip = sp->prop.dev;
+        ip = sp->dev;
 	strncpy (ip, dev, MAXINDIDEVICE-1);
 	ip[MAXINDIDEVICE-1] = '\0';
 
-	ip = sp->prop.name;
+        ip = sp->name;
 	strncpy (ip, name, MAXINDINAME-1);
 	ip[MAXINDINAME-1] = '\0';
@@ -1325,7 +1353,7 @@
 }
 
-/* return Snoopee if dp is snooping dev/name, else NULL.
- */
-static Snoopee *
+/* return Property if dp is snooping dev/name, else NULL.
+ */
+static Property *
 findSDevice (DvrInfo *dp, const char *dev, const char *name)
 {
@@ -1333,8 +1361,7 @@
 
 	for (i = 0; i < dp->nsprops; i++) {
-	    Snoopee *sp = &dp->sprops[i];
-	    Property *pp = &sp->prop;
-	    if (!strcmp (pp->dev, dev) &&
-		    (!pp->name[0] || !strcmp(pp->name, name)))
+            Property *sp = &dp->sprops[i];
+            if (!strcmp (sp->dev, dev) &&
+                    (!sp->name[0] || !strcmp(sp->name, name)))
 		return (sp);
 	}
@@ -1342,4 +1369,5 @@
 	return (NULL);
 }
+
 
 /* put Msg mp on queue of each client interested in dev/name, except notme.
@@ -1352,5 +1380,5 @@
 	int shutany = 0;
 	ClInfo *cp;
-	int ql;
+        int ql,i=0;
 
 	/* queue message to each interested client */
@@ -1359,8 +1387,33 @@
 	    if (!cp->active || cp == notme)
 		continue;
-	    if (findClDevice (cp, dev, name) < 0)
+            if (findClDevice (cp, dev, name) < 0)
 		continue;
-	    if ((isblob && cp->blob==B_NEVER) || (!isblob && cp->blob==B_ONLY))
-		continue;
+
+            //if ((isblob && cp->blob==B_NEVER) || (!isblob && cp->blob==B_ONLY))
+            if (!isblob && cp->blob==B_ONLY)
+                continue;
+
+            if (isblob)
+            {
+                if (cp->nprops > 0)
+                {
+                Property *pp = NULL;
+                int blob_found=0;
+                for (i = 0; i < cp->nprops; i++)
+                {
+                    pp = &cp->props[i];
+                    if (!strcmp (pp->dev, dev) && (!strcmp(pp->name, name)))
+                    {
+                        blob_found = 1;
+                        break;
+                    }
+                }
+
+                if ( (blob_found && pp->blob == B_NEVER) || (blob_found==0 && cp->blob == B_NEVER) )
+                    continue;
+               }
+               else if (cp->blob == B_NEVER)
+                   continue;
+           }
 
 	    /* shut down this client if its q is already too large */
@@ -1568,10 +1621,10 @@
 	int i;
 
-	if (cp->allprops || !dev[0])
+        if (cp->allprops || !dev[0])
 	    return (0);
-	for (i = 0; i < cp->nprops; i++) {
-	    Property *pp = &cp->props[i];
-	    if (!strcmp (pp->dev, dev) &&
-                                    (!pp->name[0] || !strcmp(pp->name, name)))
+        for (i = 0; i < cp->nprops; i++)
+        {
+            Property *pp = &cp->props[i];
+            if (!strcmp (pp->dev, dev) && (!pp->name[0] || !strcmp(pp->name, name)))
 		return (0);
 	}
@@ -1582,19 +1635,29 @@
  */
 static void
-addClDevice (ClInfo *cp, const char *dev, const char *name)
+addClDevice (ClInfo *cp, const char *dev, const char *name, int isblob)
 {
 	Property *pp;
 	char *ip;
-
+        int i=0;
+
+        if (isblob)
+        {
+            for (i = 0; i < cp->nprops; i++)
+            {
+                Property *pp = &cp->props[i];
+                if (!strcmp (pp->dev, dev) && (!pp->name[0] || !strcmp(pp->name, name)))
+                    return;
+            }
+        }
 	/* no dups */
-	if (!findClDevice (cp, dev, name))
+        else if (!findClDevice (cp, dev, name))
 	    return;
 
 	/* add */
 	cp->props = (Property *) realloc (cp->props,
-					    (cp->nprops+1)*sizeof(Property));
+                                            (cp->nprops+1)*sizeof(Property));
 	pp = &cp->props[cp->nprops++];
 
-	ip = pp->dev;
+        /*ip = pp->dev;
 	strncpy (ip, dev, MAXINDIDEVICE-1);
 	ip[MAXINDIDEVICE-1] = '\0';
@@ -1602,5 +1665,9 @@
 	ip = pp->name;
 	strncpy (ip, name, MAXINDINAME-1);
-	ip[MAXINDINAME-1] = '\0';
+        ip[MAXINDINAME-1] = '\0';*/
+
+        strncpy (pp->dev, dev, MAXINDIDEVICE);
+        strncpy (pp->name, name, MAXINDINAME);
+        pp->blob = B_NEVER;
 }
 
@@ -1632,5 +1699,5 @@
  */
 static void
-crackBLOB (char *enableBLOB, BLOBHandling *bp)
+crackBLOB (const char *enableBLOB, BLOBHandling *bp)
 {
 	if (!strcmp (enableBLOB, "Also"))
@@ -1640,4 +1707,31 @@
 	else if (!strcmp (enableBLOB, "Never"))
 	    *bp = B_NEVER;
+}
+
+/* Update the client property BLOB handling policy */
+static void crackBLOBHandling(const char *dev, const char *name, const char *enableBLOB, ClInfo *cp)
+{
+    int i=0;
+
+    /* If we have EnableBLOB with property name, we add it to Client device list */
+    if (name[0])
+        addClDevice (cp, dev, name, 1);
+    else
+    /* Otherwise, we set the whole client blob handling to what's passed (enableBLOB) */
+        crackBLOB(enableBLOB, &cp->blob);
+
+    /* If whole client blob handling policy was updated, we need to pass that also to all children
+       and if the request was for a specific property, then we apply the policy to it */
+    for (i = 0; i < cp->nprops; i++)
+    {
+        Property *pp = &cp->props[i];
+        if (!name[0])           
+            crackBLOB(enableBLOB, &pp->blob);
+        else if (!strcmp (pp->dev, dev) && (!strcmp(pp->name, name)))
+        {
+            crackBLOB(enableBLOB, &pp->blob);
+            return;
+        }
+    }
 }
 
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 504)
@@ -20,4 +20,6 @@
     cServer = "localhost";
     cPort   = 7624;
+    svrwfp = NULL;    
+    sConnected = false;
 
 }
@@ -26,7 +28,5 @@
 INDI::BaseClient::~BaseClient()
 {
-
-    disconnect();
-
+    close(sockfd);
 }
 
@@ -43,5 +43,5 @@
 }
 
-bool INDI::BaseClient::connect()
+bool INDI::BaseClient::connectServer()
 {
     struct sockaddr_in serv_addr;
@@ -76,5 +76,4 @@
     /* prepare for line-oriented i/o with client */
     svrwfp = fdopen (sockfd, "w");
-    svrrfp = fdopen (sockfd, "r");
 
     int result = pthread_create( &listen_thread, NULL, &INDI::BaseClient::listenHelper, this);
@@ -86,30 +85,82 @@
     }
 
+    serverConnected();
+    sConnected = true;
+
     return true;
 }
 
-void INDI::BaseClient::disconnect()
-{
-    char errmsg[MAXRBUF];
-    removeDevice(NULL, errmsg);
-    if (lillp)
-        delLilXML(lillp);
-    lillp = NULL;
-    pthread_cancel(listen_thread);
-    close(sockfd);
-    if (svrwfp)
+bool INDI::BaseClient::disconnectServer()
+{
+    if (sConnected == false)
+        return true;
+
+    if (svrwfp != NULL)
         fclose(svrwfp);
-    svrwfp = NULL;
-    if (svrrfp)
-        fclose(svrrfp);
-    svrrfp = NULL;
-}
-
-INDI::BaseDriver * INDI::BaseClient::getDevice(const char * deviceName)
-{
-    vector<INDI::BaseDriver *>::const_iterator devi;
+   svrwfp = NULL;
+
+   close(sockfd);
+
+    serverDisconnected();
+
+    sConnected = false;
+
+    return true;
+}
+
+
+void INDI::BaseClient::setDriverConnection(bool status, const char *deviceName)
+{
+    INDI::BaseDriver *drv = getDriver(deviceName);
+    ISwitchVectorProperty *drv_connection = NULL;
+
+    if (drv == NULL)
+    {
+        IDLog("INDI::BaseClient: Error. Unable to find driver %s\n", deviceName);
+        return;
+    }
+
+    drv_connection = drv->getSwitch("CONNECTION");
+
+    if (drv_connection == NULL)
+        return;
+
+    // If we need to connect
+    if (status)
+    {
+        // If there is no need to do anything, i.e. already connected.
+        if (drv_connection->sp[0].s == ISS_ON)
+            return;
+
+        IUResetSwitch(drv_connection);
+        drv_connection->s = IPS_BUSY;
+        drv_connection->sp[0].s = ISS_ON;
+        drv_connection->sp[1].s = ISS_OFF;
+
+        sendNewSwitch(drv_connection, &(drv_connection->sp[0]));
+    }
+    else
+    {
+        // If there is no need to do anything, i.e. already disconnected.
+        if (drv_connection->sp[1].s == ISS_ON)
+            return;
+
+        IUResetSwitch(drv_connection);
+        drv_connection->s = IPS_BUSY;
+        drv_connection->sp[0].s = ISS_OFF;
+        drv_connection->sp[1].s = ISS_ON;
+
+        sendNewSwitch(drv_connection, &(drv_connection->sp[1]));
+
+    }
+}
+
+
+INDI::BaseDriver * INDI::BaseClient::getDriver(const char * deviceName)
+{
+    vector<devicePtr>::const_iterator devi;
     for ( devi = cDevices.begin(); devi != cDevices.end(); devi++)
         if (!strcmp(deviceName, (*devi)->deviceName()))
-            return (*devi);
+            return (*devi).get();
 
     return NULL;
@@ -141,15 +192,12 @@
 
     /* read from server, exit if find all requested properties */
-    while (1)
-    {
-        n = fread(buffer, 1, MAXINDIBUF, svrrfp);
+    while (sConnected)
+    {
+        n = read(sockfd, buffer, MAXINDIBUF);
 
         if (n ==0)
         {
-            if (ferror(svrrfp))
-                perror ("read");
-            else
-                fprintf (stderr,"INDI server %s/%d disconnected\n", cServer.c_str(), cPort);
-
+            perror ("read");
+            fprintf (stderr,"INDI server %s/%d disconnected\n", cServer.c_str(), cPort);
             serverDisconnected();
             return;
@@ -180,4 +228,5 @@
         }
     }
+
 }
 
@@ -242,12 +291,12 @@
 int INDI::BaseClient::removeDevice( const char * devName, char * errmsg )
 {
-    std::vector<INDI::BaseDriver *>::iterator devicei = cDevices.begin();
+    std::vector<devicePtr>::iterator devicei = cDevices.begin();
 
     while (devicei != cDevices.end())
     {
-      if (devName == NULL || !strcmp(devName, (*devicei)->deviceName()))
+      if (strcmp(devName, (*devicei)->deviceName()))
       {
           cDevices.erase(devicei);
-          delete (*devicei);
+          //delete (*devicei);
           return 0;
       }
@@ -263,10 +312,10 @@
 {
 
-    std::vector<INDI::BaseDriver *>::const_iterator devicei;
+    std::vector<devicePtr>::const_iterator devicei;
 
     for (devicei = cDevices.begin(); devicei != cDevices.end(); devicei++)
     {
         if (!strcmp(devName, (*devicei)->deviceName()))
-         return (*devicei);
+         return (*devicei).get();
 
     }
@@ -279,5 +328,5 @@
 INDI::BaseDriver * INDI::BaseClient::addDevice (XMLEle *dep, char * errmsg)
 {
-    INDI::BaseDriver *dp;
+    devicePtr dp(new INDI::BaseDriver());
     XMLAtt *ap;
     char * device_name;
@@ -293,5 +342,4 @@
     device_name = valuXMLAtt(ap);
 
-    dp = new INDI::BaseDriver();
     dp->setMediator(this);
     dp->setDeviceName(device_name);
@@ -299,8 +347,8 @@
     cDevices.push_back(dp);
 
-    newDevice();
+    newDevice(device_name);
 
     /* ok */
-    return dp;
+    return dp.get();
 }
 
@@ -467,16 +515,13 @@
 void INDI::BaseClient::setBLOBMode(BLOBHandling blobH, const char *dev, const char *prop)
 {
-    char blobOpenTag[64];
-
-    if (dev)
-    {
-        if (prop)
-            snprintf(blobOpenTag, 64, "<enableBLOB device='%s' name='%s'>", dev, prop);
-        else
-            snprintf(blobOpenTag, 64, "<enableBLOB device='%s'>", dev);
-    }
-    else
-        snprintf(blobOpenTag, 64, "<enableBLOB>", dev, prop);
-
+    char blobOpenTag[MAXRBUF];
+
+    if (!dev[0])
+        return;
+
+   if (prop != NULL)
+           snprintf(blobOpenTag, MAXRBUF, "<enableBLOB device='%s' name='%s'>", dev, prop);
+   else
+          snprintf(blobOpenTag, MAXRBUF, "<enableBLOB device='%s'>", dev);
 
     switch (blobH)
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 504)
@@ -4,4 +4,5 @@
 #include <vector>
 #include <map>
+#include <boost/shared_ptr.hpp>
 #include <string>
 
@@ -32,7 +33,8 @@
 public:
     enum { INDI_DEVICE_NOT_FOUND=-1, INDI_PROPERTY_INVALID=-2, INDI_PROPERTY_DUPLICATED = -3, INDI_DISPATCH_ERROR=-4 };
+    typedef boost::shared_ptr<INDI::BaseDriver> devicePtr;
 
     BaseClient();
-    virtual ~BaseClient();
+    ~BaseClient();
 
     /** \brief Set the server host name and port
@@ -57,21 +59,28 @@
         \note This function blocks until connection is either successull or unsuccessful.
     */
-    bool connect();
+    bool connectServer();
 
     /** \brief Disconnect from INDI server.
 
         Disconnects from INDI servers. Any devices previously created will be deleted and memory cleared.
+        \return True if disconnection is successful, false otherwise.
     */
-    void disconnect();
+    bool disconnectServer();
 
+    /** \brief Connect/Disconnect to INDI driver
+        \param status If true, the client will attempt to turn on CONNECTION property within the driver (i.e. turn on the device).
+         Otherwise, CONNECTION will be turned off.
+        \param deviceName Name of the device to connect to.
+    */
+    void setDriverConnection(bool status, const char *deviceName);
 
     /** \param deviceName Name of device to search for in the list of devices owned by INDI server,
          \returns If \e deviceName exists, it returns an instance of the device. Otherwise, it returns NULL.
     */
-    INDI::BaseDriver * getDevice(const char * deviceName);
+    INDI::BaseDriver * getDriver(const char * deviceName);
 
     /** \returns Returns a vector of all devices created in the client.
     */
-    const vector<INDI::BaseDriver *> & getDevices() const { return cDevices; }
+    const vector<devicePtr> & getDrivers() const { return cDevices; }
 
     /** \brief Set Binary Large Object policy mode
@@ -86,11 +95,11 @@
       If \e dev and \e prop are supplied, then the BLOB handling policy is set for this particular device and property.
       if \e prop is NULL, then the BLOB policy applies to the whole device.
-      if \e dev is NULL, then the BLOB policy applies to all devices owned by INDI server.
+
 
       \param blobH BLOB handling policy
-      \param dev name of device
-      \param prop name of property
+      \param dev name of device, required.
+      \param prop name of property, optional.
     */
-    void setBLOBMode(BLOBHandling blobH, const char *dev = NULL, const char *prop = NULL);
+    void setBLOBMode(BLOBHandling blobH, const char *dev, const char *prop = NULL);
 
     // Update
@@ -143,9 +152,10 @@
     pthread_t listen_thread;
 
-    vector<INDI::BaseDriver *> cDevices;
+    vector<devicePtr> cDevices;
     vector<string> cDeviceNames;
 
     string cServer;
     unsigned int cPort;
+    bool sConnected;
 
     // Parse & FILE buffers for IO
@@ -153,5 +163,4 @@
     LilXML *lillp;			/* XML parser context */
     FILE *svrwfp;			/* FILE * to talk to server */
-    FILE *svrrfp;			/* FILE * to read from server */
 
 };
